/**Clase que permite comprobar el correcto funcionamiento del proyecto
 * @author Nicolas Montoya - Eduardo Toro
 */
import java.awt.*;
import java.lang.Math.*;
import java.util.*;

public class TestForma{
   public static void main(String[] args){
	     Point x = new Point(1,1);
		  Point y = new Point(2,2);
		  Point z = new Point(3,3);
		  Point w = new Point(4,4);
		  
		  Circulo c = new Circulo(2);
		  Linea l = new Linea(x,y);
	     Triangulo t = new Triangulo(x,y,z);
		  Rectangulo r = new Rectangulo(2,2);
		  
		  ArrayList<Forma> formas = new ArrayList<Forma>();
		  formas.add(c);
		  formas.add(l);
		  formas.add(t);
		  formas.add(r);

        System.out.println("Comprobando que los metodos implementados funcionen de manera correcta");
	  
		  for(int i = 0; i < formas.size(); i++)
		     {
			   System.out.println("Creando Figura...");
		      System.out.println(((Forma)formas.get(i)).toString());
				System.out.println("Trasladando en (1,1)");
		      ((Forma)formas.get(i)).trasladar(1,1);
				System.out.println(((Forma)formas.get(i)).toString());
				System.out.println("Escalando en un factor 2 con respecto al punto:("+z.getX()+","+z.getY()+").");
				((Forma)formas.get(i)).escalar(z,2);
				System.out.println(((Forma)formas.get(i)).toString());
				System.out.println("Rotando con respecto al punto:("+w.getX()+","+w.getY()+") en un angulo de 135 grados.");
				((Forma)formas.get(i)).rotar(w,(3*Math.PI)/4);
				System.out.println(((Forma)formas.get(i)).toString());
				System.out.println("\n");

				}			
		   
		      System.out.println("Creando clonacion de cada una de las formas finales:");
		      ArrayList<Forma> formasclonadas= new ArrayList<Forma>();
            formasclonadas.add(c.clone());
				formasclonadas.add(l.clone());
				formasclonadas.add(t.clone());
				formasclonadas.add(r.clone());
		      for(int i = 0; i < formasclonadas.size(); i++){
		         System.out.println(((Forma)formasclonadas.get(i)).toString());
		         }
				System.out.println("\n");	
				
				System.out.println("Trasladando las formas clonadas en (1,1):");
		       for(int i = 0; i < formasclonadas.size(); i++){
				   ((Forma)formasclonadas.get(i)).trasladar(1,1);
		         System.out.println(((Forma)formasclonadas.get(i)).toString());
		         }
		     	System.out.println("\n");	
				
				System.out.println("Trasladando las formas clonadas en (-1,-1):");
		       for(int i = 0; i < formasclonadas.size(); i++){
				   ((Forma)formasclonadas.get(i)).trasladar(-1,-1);
		         System.out.println(((Forma)formasclonadas.get(i)).toString());
		         }
		     System.out.println("\n");
			  System.out.println("Comprobando que las formas clonadas sean iguales a las iniciales: ");
			  if(c.equals(((Forma)formasclonadas.get(0)))) System.out.println("Comprobado Circulos...Circulos iguales!!");
			  if(l.equals(((Forma)formasclonadas.get(1)))) System.out.println("Comprobado Lineas...Lineas iguales!!");
			  if(t.equals(((Forma)formasclonadas.get(2)))) System.out.println("Comprobado Triangulos...Triangulos iguales!!");
			  if(r.equals(((Forma)formasclonadas.get(3)))) System.out.println("Comprobado Rectangulos...Rectangulos iguales!!");
		
	}
}
